#!/usr/bin/bash

#########################################################
#
# Получение списка учёток с включенным доступом по POP3
# и выключение доступа
#
#########################################################
# Автор: Сергей Калинин
# https://nuk-svk.ru 
# svk@nuk-svk.ru
#########################################################


# Получаем список аккаунтов со статусом "active"
/opt/zimbra/bin/zmaccts | /usr/bin/grep -E "active" | grep -E "@(domain1|domain2|domain3)\.ru" | awk '{print $1}' | while read ACCOUNT; do
    # для каждого аккаунта получаем настройки доступа
    ACCOUNT_STR=$(/opt/zimbra/bin/zmprov ga ${ACCOUNT} zimbraFeaturePop3DataSourceEnabled zimbraPop3Enabled)
    #echo ${ACCOUNT_STR}
    POP3_EXT_ACCESS=$(echo $ACCOUNT_STR | grep -E -i -o "zimbraFeaturePop3DataSourceEnabled:\s+(TRUE)" | awk '{print $2}')

    # и если статус TRUE, генерим команду для изменения
    if [ ${POP3_EXT_ACCESS} ]; then
        POP3_EXT_DISABLED_CMD="zimbraFeaturePop3DataSourceEnabled FALSE"
    fi

    POP3_ACCESS=$(echo $ACCOUNT_STR | grep -E -i -o "zimbraPop3Enabled:\s+(TRUE)" | awk '{print $2}')

    if [ ${POP3_ACCESS} ]; then
        POP3_DISABLED_CMD="zimbraPop3Enabled FALSE"
    fi

    # если хоть одна из настроек была включена (статус TRUE) то выполняем команду.
    echo "$ACCOUNT, POP3=${POP3_ACCESS}, POP3_EXT=${POP3_EXT_ACCESS}"
    if [[ $POP3_EXT_ACCESS || ${POP3_ACCESS} ]]; then
        /opt/zimbra/bin/zmprov ma ${ACCOUNT} ${POP3_EXT_DISABLED_CMD} ${POP3_DISABLED_CMD}
    fi

done
