#!/bin/bash

################################################
#
# Включение отправки исходящей почты
#        через другой сервер
#
# Автор: Сергей Калинин
# https://nuk-svk.ru 
# svk@nuk-svk.ru
################################################
#
# Использование:
# - включение отправки через релей:
#
#   ./zimbra_mta_relay_change TARGET_HOST RELAY_HOST
#
# - отключение отправки через релей
#
#   ./zimbra_mta_relay_change TARGET_HOST
#
###############################################


ZIMBRA_BIN=/opt/zimbra/bin
TARGET_HOST=${1}
RELAY_HOST=${2}

if [ -z "$1" ]; then
    echo "usage for enable relay sending:"
    echo "    ./zimbra_mta_relay_change TARGET_HOST RELAY_HOST"
    echo ""
    echo "usage for disable relay sending:"
    echo "    ./zimbra_mta_relay_change TARGET_HOST"
    exit
fi
if [ -z "$2" ]; then
    $ZIMBRA_BIN/zmprov ms "${TARGET_HOST}" zimbraMtaRelayHost ""
    $ZIMBRA_BIN/zmprov ms "${TARGET_HOST}" zimbraMtaMyDestination "localhost"
else
    $ZIMBRA_BIN/zmprov ms "${TARGET_HOST}" zimbraMtaRelayHost "${RELAY_HOST}:25"
    $ZIMBRA_BIN/zmprov ms "${TARGET_HOST}" zimbraMtaMyDestination "localhost ${RELAY_HOST}"
fi

$ZIMBRA_BIN/zmmtactl stop
$ZIMBRA_BIN/zmmtactl start
